#include "kernelsolver.h"

void processInitializationCuBlas(double *&MatrixA, double *&MatrixB, double *&Result, int Size){
  MatrixA = new double[Size * Size];
  MatrixB = new double[Size];
  Result = new double[Size];

  REP (i, Size){
    MatrixB[i]=1;

    REP (j, Size) {
      MatrixA[i * Size + j]=i;
    }
  }
}

void processInitialization(double *&MatrixA, double *&MatrixB, double *&Result, dim3 dimsA, dim3 dimsB, dim3 dimsC){
  MatrixA = new double[dimsA.x * dimsA.y];
  MatrixB = new double[dimsB.x * dimsB.y];
  Result = new double[dimsC.x * dimsC.y];

  REP (i, dimsA.y){
    REP (j, dimsA.x) {
      MatrixA[i * dimsA.x + j]=i;

      if (j < dimsB.x) MatrixB[i * dimsB.x + j]=1;
    }
  }
}

void processTermination(double *MatrixA, double *MatrixB, double *Result){
  delete[] MatrixA;
  delete[] MatrixB;
  delete[] Result;
}
