#ifndef KERNELSOLVER_H
  #define KERNELSOLVER_H

  #include <bits/stdc++.h>
  using namespace std;

  #include <cuda_runtime.h>
  #include <cublas_v2.h>

  #define REP(i, n) for(int i = 0; i < n; i++)

  void processInitializationCuBlas(double *&MatrixA, double *&MatrixB, double *&Result, int Size);
  void processInitialization(double *&matrixA, double *&matrixB, double *&matrixResult, dim3 dimsA, dim3 dimsB, dim3 dimsC);
  void processTermination(double *matrixA, double *matrixB, double *matrixResult);

  float solve(double *h_A, double *h_B, double *h_C, dim3 &dimsA, dim3 &dimsB, dim3 &dimsC);
  float solve_cublas(double *matrixA, double *matrixB, double *matrixResult, int n);
#endif
